/* Jeff DeMaagd
Date: 08/08/1998

Purpose:
This code is found in a previously butchered form in the Linux Journal,
October 1997, Issue 42.  You'd think that they'd proof-read these things 
or actually try to read or use the code, but hey, no one is perfect.  I
really hated this guy's formatting, which is very difficult to make sense
of.  I wonder if that is K&R C.  It looks pretty messed up, which is a reason
I don't use Emacs' auto formatting system.

Original author: David Mosberger.*/

#include <math.h>

static inline unsigned int realcc (void)
{
	unsigned long cc;
	asm volatile ("rpcc %0" : "=r"(cc) : : "memory");
	return cc;
}

static inline unsigned int virtcc (void)
{
	unsigned long cc;
	asm volatile ("rpcc %0" : "=r"(cc) : : "memory");
	return (cc + (cc << 32)) >> 32;
}

void measure_sqrt (void)
{
	unsigned int start, stop, time[10];
	int i;
	float x = 2.0;

	for (i = 0; i < 10 ; ++i)
	{
		x = 2.0;
		start = realcc();
		sqrt (x);
		stop = realcc();
		time[i] = stop - start;
	}

	for (i = 0; i <10 ; ++i)
	{
		printf (" %u", time[i]);
	}
	printf ("\n");
}

int main (void)
{
	measure_sqrt ();	
	return;
}
